Xerces-J API: Class ElementImpl

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.dom
Class ElementImpl

    java.lang.Object
      |
      +--org.apache.xerces.dom.NodeImpl
            |
            +--org.apache.xerces.dom.ChildNode
                  |
                  +--org.apache.xerces.dom.ParentNode
                        |
                        +--org.apache.xerces.dom.ElementImpl

Direct Known Subclasses:
  DeferredElementImpl, ElementNSImpl, HTMLElementImpl, WMLElementImpl

public class ElementImpl
extends ParentNode
implements Element

Elements represent most of the "markup" and structure of the document. They contain both the data for the element itself (element name and attributes), and any contained nodes, including document text (as children).

Elements may have Attributes associated with them; the API for this is defined in Node, but the function is implemented here. In general, XML applications should retrive Attributes as Nodes, since they may contain entity references and hence be a fairly complex sub-tree. HTML users will be dealing with simple string values, and convenience methods are provided to work in terms of Strings.

ElementImpl does not support Namespaces. ElementNSImpl, which inherits from it, does.

Since:
  PR-DOM-Level-1-19980818.
Version:
Author:
  Arnaud Le Hors, IBM, Joe Kesselman, IBM, Andy Clark, IBM, Ralf Pfeiffer, IBM
See Also:
  `ElementNSImpl`, Serialized Form

Field Summary
`protected AttributeMap` | `attributes` Attributes.
`protected java.lang.String` | `name` Element name.

Fields inherited from class org.apache.xerces.dom.ParentNode
`fCachedChild, fCachedChildIndex, fCachedLength, firstChild, ownerDocument`

Fields inherited from class org.apache.xerces.dom.ChildNode
`nextSibling, previousSibling`

Fields inherited from class org.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, IGNORABLEWS, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, UNNORMALIZED`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`protected` | `ElementImpl()`
`` | `ElementImpl(CoreDocumentImpl ownerDoc, java.lang.String name)` Factory constructor.

Method Summary
`Node` | `cloneNode(boolean deep)` Return a duplicate copy of this Element.
`java.lang.String` | `getAttribute(java.lang.String name)` Look up a single Attribute by name.
`Attr` | `getAttributeNode(java.lang.String name)` Look up a single Attribute by name.
`Attr` | `getAttributeNodeNS(java.lang.String namespaceURI, java.lang.String localName)` Retrieves an Attr node by local name and namespace URI.
`java.lang.String` | `getAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Introduced in DOM Level 2.
`NamedNodeMap` | `getAttributes()` Retrieve all the Attributes as a set.
`protected NamedNodeMapImpl` | `getDefaultAttributes()` Get the default attributes.
`NodeList` | `getElementsByTagName(java.lang.String tagname)` Returns a NodeList of all descendent nodes (children, grandchildren, and so on) which are Elements and which have the specified tag name.
`NodeList` | `getElementsByTagNameNS(java.lang.String namespaceURI, java.lang.String localName)` Introduced in DOM Level 2.
`java.lang.String` | `getNodeName()` Returns the element name
`short` | `getNodeType()` A short integer indicating what type of node this is.
`java.lang.String` | `getTagName()` Returns the name of the Element.
`boolean` | `hasAttribute(java.lang.String name)` Introduced in DOM Level 2.
`boolean` | `hasAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Introduced in DOM Level 2.
`boolean` | `hasAttributes()` Introduced in DOM Level 2.
`void` | `normalize()` In "normal form" (as read from a source file), there will never be two Text children in succession.
`protected void` | `reconcileDefaultAttributes()` Reconcile default attributes.
`void` | `removeAttribute(java.lang.String name)` Remove the named attribute from this Element.
`Attr` | `removeAttributeNode(Attr oldAttr)` Remove the specified attribute/value pair.
`void` | `removeAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Introduced in DOM Level 2.
`void` | `setAttribute(java.lang.String name, java.lang.String value)` Add a new name/value pair, or replace the value of the existing attribute having that name.
`Attr` | `setAttributeNode(Attr newAttr)` Add a new attribute/value pair, or replace the value of the existing attribute with that name.
`Attr` | `setAttributeNodeNS(Attr newAttr)` Introduced in DOM Level 2.
`void` | `setAttributeNS(java.lang.String namespaceURI, java.lang.String localName, java.lang.String value)` Introduced in DOM Level 2.
`void` | `setReadOnly(boolean readOnly, boolean deep)` NON-DOM: Subclassed to flip the attributes' readonly switch as well.
`protected void` | `setupDefaultAttributes()` Setup the default attributes.
`protected void` | `synchronizeData()` Synchronizes the data (name and value) for fast nodes.

Methods inherited from class org.apache.xerces.dom.ParentNode
`getChildNodes, getChildNodesUnoptimized, getFirstChild, getLastChild, getLength, getOwnerDocument, hasChildNodes, insertBefore, item, removeChild, replaceChild, synchronizeChildren`

Methods inherited from class org.apache.xerces.dom.ChildNode
`getNextSibling, getParentNode, getPreviousSibling`

Methods inherited from class org.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, changed, changes, dispatchEvent, getLocalName, getNamespaceURI, getNodeValue, getPrefix, getReadOnly, getUserData, isSupported, removeEventListener, setNodeValue, setPrefix, setUserData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### name

    protected java.lang.String name

  Element name.

### attributes

    protected AttributeMap attributes

  Attributes.

Constructor Detail

### ElementImpl

    public ElementImpl(CoreDocumentImpl ownerDoc,
                       java.lang.String name)

  Factory constructor.

### ElementImpl

    protected ElementImpl()

Method Detail

### getNodeType

    public short getNodeType()

  A short integer indicating what type of node this is. The named constants for this value are defined in the org.w3c.dom.Node interface.
  Overrides:
    getNodeType in class NodeImpl

### getNodeName

    public java.lang.String getNodeName()

  Returns the element name
  Overrides:
    getNodeName in class NodeImpl

### getAttributes

    public NamedNodeMap getAttributes()

  Retrieve all the Attributes as a set. Note that this API is inherited from Node rather than specified on Element; in fact only Elements will ever have Attributes, but they want to allow folks to "blindly" operate on the tree as a set of Nodes.
  Overrides:
    getAttributes in class NodeImpl
  Tags copied from class: NodeImpl
  See Also:
    `ElementImpl`

### cloneNode

    public Node cloneNode(boolean deep)

  Return a duplicate copy of this Element. Note that its children will not be copied unless the "deep" flag is true, but Attributes are always replicated.
  Overrides:
    cloneNode in class ParentNode
  See Also:
    `Node.cloneNode(boolean)`

### getAttribute

    public java.lang.String getAttribute(java.lang.String name)

  Look up a single Attribute by name. Returns the Attribute's string value, or an empty string (NOT null!) to indicate that the name did not map to a currently defined attribute.

  Note: Attributes may contain complex node trees. This method returns the "flattened" string obtained from Attribute.getValue(). If you need the structure information, see getAttributeNode().

  Specified by:
    getAttribute in interface Element
  Tags copied from interface: Element
  Parameters:
    `nameThe` - name of the attribute to retrieve.
  Returns:
    The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.

### getAttributeNode

    public Attr getAttributeNode(java.lang.String name)

  Look up a single Attribute by name. Returns the Attribute Node, so its complete child tree is available. This could be important in XML, where the string rendering may not be sufficient information.

  If no matching attribute is available, returns null.

  Specified by:
    getAttributeNode in interface Element
  Tags copied from interface: Element
  Parameters:
    `nameThe` - name (`nodeName`) of the attribute to retrieve.
  Returns:
    The `Attr` node with the specified name ( `nodeName`) or `null` if there is no such attribute.

### getElementsByTagName

    public NodeList getElementsByTagName(java.lang.String tagname)

  Returns a NodeList of all descendent nodes (children, grandchildren, and so on) which are Elements and which have the specified tag name.

  Note: NodeList is a "live" view of the DOM. Its contents will change as the DOM changes, and alterations made to the NodeList will be reflected in the DOM.

  Specified by:
    getElementsByTagName in interface Element
  Parameters:
    `tagname` - The type of element to gather. To obtain a list of all elements no matter what their names, use the wild-card tag name "*".
  See Also:
    `DeepNodeListImpl`

### getTagName

    public java.lang.String getTagName()

  Returns the name of the Element. Note that Element.nodeName() is defined to also return the tag name.

  This is case-preserving in XML. HTML should uppercasify it on the way in.

  Specified by:
    getTagName in interface Element

### normalize

    public void normalize()

  In "normal form" (as read from a source file), there will never be two Text children in succession. But DOM users may create successive Text nodes in the course of manipulating the document. Normalize walks the sub-tree and merges adjacent Texts, as if the DOM had been written out and read back in again. This simplifies implementation of higher-level functions that may want to assume that the document is in standard form.

  To normalize a Document, normalize its top-level Element child.

  As of PR-DOM-Level-1-19980818, CDATA -- despite being a subclass of Text -- is considered "markup" and will _not_ be merged either with normal Text or with other CDATASections.

  Overrides:
    normalize in class ParentNode

### removeAttribute

    public void removeAttribute(java.lang.String name)

  Remove the named attribute from this Element. If the removed Attribute has a default value, it is immediately replaced thereby.

  The default logic is actually implemented in NamedNodeMapImpl. PR-DOM-Level-1-19980818 doesn't fully address the DTD, so some of this behavior is likely to change in future versions. ?????

  Note that this call "succeeds" even if no attribute by this name existed -- unlike removeAttributeNode, which will throw a not-found exception in that case.

  Specified by:
    removeAttribute in interface Element
  Throws:
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if the node is readonly.

### removeAttributeNode

    public Attr removeAttributeNode(Attr oldAttr)
                             throws DOMException

  Remove the specified attribute/value pair. If the removed Attribute has a default value, it is immediately replaced.

  NOTE: Specifically removes THIS NODE -- not the node with this name, nor the node with these contents. If the specific Attribute object passed in is not stored in this Element, we throw a DOMException. If you really want to remove an attribute by name, use removeAttribute().

  Specified by:
    removeAttributeNode in interface Element
  Returns:
    the Attribute object that was removed.
  Throws:
    DOMException(NOT_FOUND_ERR) - if oldattr is not an attribute of this Element.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if the node is readonly.

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.String value)

  Add a new name/value pair, or replace the value of the existing attribute having that name. Note: this method supports only the simplest kind of Attribute, one whose value is a string contained in a single Text node. If you want to assert a more complex value (which XML permits, though HTML doesn't), see setAttributeNode(). The attribute is created with specified=true, meaning it's an explicit value rather than inherited from the DTD as a default. Again, setAttributeNode can be used to achieve other results.
  Specified by:
    setAttribute in interface Element
  Throws:
    DOMException(INVALID_NAME_ERR) - if the name is not acceptable. (Attribute factory will do that test for us.)
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if the node is readonly.

### setAttributeNode

    public Attr setAttributeNode(Attr newAttr)
                          throws DOMException

  Add a new attribute/value pair, or replace the value of the existing attribute with that name.

  This method allows you to add an Attribute that has already been constructed, and hence avoids the limitations of the simple setAttribute() call. It can handle attribute values that have arbitrarily complex tree structure -- in particular, those which had entity references mixed into their text.

  Specified by:
    setAttributeNode in interface Element
  Throws:
    DOMException(INUSE_ATTRIBUTE_ERR) - if the Attribute object has already been assigned to another Element.

### getAttributeNS

    public java.lang.String getAttributeNS(java.lang.String namespaceURI,
                                           java.lang.String localName)

  Introduced in DOM Level 2.

  Retrieves an attribute value by local name and namespace URI.

  Specified by:
    getAttributeNS in interface Element
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to retrieve.
    `localName` - The local name of the attribute to retrieve.
  Returns:
    String The Attr value as a string, or empty string if that attribute does not have a specified or default value.
  Since:
    WD-DOM-Level-2-19990923

### setAttributeNS

    public void setAttributeNS(java.lang.String namespaceURI,
                               java.lang.String localName,
                               java.lang.String value)

  Introduced in DOM Level 2.

  Adds a new attribute. If the given namespaceURI is null or an empty string and the qualifiedName has a prefix that is "xml", the new attribute is bound to the predefined namespace "http://www.w3.org/XML/1998/namespace" [Namespaces]. If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the qualifiedName, and its value is changed to be the value parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an Attr node plus any Text and EntityReference nodes, build the appropriate subtree, and use setAttributeNodeNS or setAttributeNode to assign it as the value of an attribute.

  Specified by:
    setAttributeNS in interface Element
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to create or alter.
    `localName` - The local name of the attribute to create or alter.
    `value` - The value to set in string form.
  Throws:
    INVALID_CHARACTER_ERR: - Raised if the specified name contains an invalid character.
    NO_MODIFICATION_ALLOWED_ERR: - Raised if this node is readonly.
    NAMESPACE_ERR: - Raised if the qualifiedName has a prefix that is "xml" and the namespaceURI is neither null nor an empty string nor "http://www.w3.org/XML/1998/namespace", or if the qualifiedName has a prefix that is "xmlns" but the namespaceURI is neither null nor an empty string, or if if the qualifiedName has a prefix different from "xml" and "xmlns" and the namespaceURI is null or an empty string.
  Since:
    WD-DOM-Level-2-19990923

### removeAttributeNS

    public void removeAttributeNS(java.lang.String namespaceURI,
                                  java.lang.String localName)

  Introduced in DOM Level 2.

  Removes an attribute by local name and namespace URI. If the removed attribute has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix.

  Specified by:
    removeAttributeNS in interface Element
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to remove.
    `localName` - The local name of the attribute to remove.
  Throws:
    NO_MODIFICATION_ALLOWED_ERR: - Raised if this node is readonly.
  Since:
    WD-DOM-Level-2-19990923

### getAttributeNodeNS

    public Attr getAttributeNodeNS(java.lang.String namespaceURI,
                                   java.lang.String localName)

  Retrieves an Attr node by local name and namespace URI.
  Specified by:
    getAttributeNodeNS in interface Element
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to retrieve.
    `localName` - The local name of the attribute to retrieve.
  Returns:
    Attr The Attr node with the specified attribute local name and namespace URI or null if there is no such attribute.
  Since:
    WD-DOM-Level-2-19990923

### setAttributeNodeNS

    public Attr setAttributeNodeNS(Attr newAttr)
                            throws DOMException

  Introduced in DOM Level 2.

  Adds a new attribute. If an attribute with that local name and namespace URI is already present in the element, it is replaced by the new one.

  Specified by:
    setAttributeNodeNS in interface Element
  Parameters:
    `Attr` - The Attr node to add to the attribute list. When the Node has no namespaceURI, this method behaves like setAttributeNode.
  Returns:
    Attr If the newAttr attribute replaces an existing attribute with the same local name and namespace URI, the * previously existing Attr node is returned, otherwise null is returned.
  Throws:
    WRONG_DOCUMENT_ERR: - Raised if newAttr was created from a different document than the one that created the element.
    NO_MODIFICATION_ALLOWED_ERR: - Raised if this node is readonly.
    INUSE_ATTRIBUTE_ERR: - Raised if newAttr is already an attribute of another Element object. The DOM user must explicitly clone Attr nodes to re-use them in other elements.
  Since:
    WD-DOM-Level-2-19990923

### hasAttributes

    public boolean hasAttributes()

  Introduced in DOM Level 2.
  Overrides:
    hasAttributes in class NodeImpl
  Tags copied from interface: Node
  Returns:
    `true` if this node has any attributes, `false` otherwise.

### hasAttribute

    public boolean hasAttribute(java.lang.String name)

  Introduced in DOM Level 2.
  Specified by:
    hasAttribute in interface Element
  Tags copied from interface: Element
  Parameters:
    `nameThe` - name of the attribute to look for.
  Returns:
    `true` if an attribute with the given name is specified on this element or has a default value, `false` otherwise.

### hasAttributeNS

    public boolean hasAttributeNS(java.lang.String namespaceURI,
                                  java.lang.String localName)

  Introduced in DOM Level 2.
  Specified by:
    hasAttributeNS in interface Element
  Tags copied from interface: Element
  Parameters:
    `namespaceURIThe` - namespace URI of the attribute to look for.
    `localNameThe` - local name of the attribute to look for.
  Returns:
    `true` if an attribute with the given local name and namespace URI is specified or has a default value on this element, `false` otherwise.

### getElementsByTagNameNS

    public NodeList getElementsByTagNameNS(java.lang.String namespaceURI,
                                           java.lang.String localName)

  Introduced in DOM Level 2.

  Returns a NodeList of all the Elements with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the Document tree, starting from this node.

  Specified by:
    getElementsByTagNameNS in interface Element
  Parameters:
    `namespaceURI` - The namespace URI of the elements to match on. The special value "*" matches all namespaces. When it is null or an empty string, this method behaves like getElementsByTagName.
    `localName` - The local name of the elements to match on. The special value "*" matches all local names.
  Returns:
    NodeList A new NodeList object containing all the matched Elements.
  Since:
    WD-DOM-Level-2-19990923

### setReadOnly

    public void setReadOnly(boolean readOnly,
                            boolean deep)

  NON-DOM: Subclassed to flip the attributes' readonly switch as well.
  Overrides:
    setReadOnly in class ParentNode
  See Also:
    `NodeImpl.setReadOnly(boolean, boolean)`

### synchronizeData

    protected void synchronizeData()

  Synchronizes the data (name and value) for fast nodes.
  Overrides:
    synchronizeData in class NodeImpl

### setupDefaultAttributes

    protected void setupDefaultAttributes()

  Setup the default attributes.

### reconcileDefaultAttributes

    protected void reconcileDefaultAttributes()

  Reconcile default attributes.

### getDefaultAttributes

    protected NamedNodeMapImpl getDefaultAttributes()

  Get the default attributes.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2001 Apache XML Project. All Rights Reserved.